/**
 * API Limits helper
 * 
 * This implementation of API limits stores
 * the counters inside memory, not in the databas
 * 
 * @author Pierre HUBERT
 */

// Different supported actions
export enum Action {
	LOGIN_FAILED = "login_failed",
	CREATE_ACCOUNT = "create_account"
}

/**
 * The duration entries will be kept in the table
 */
const MAX_TIME = 3600; // 1 hour

/**
 * Information about a specific IP & action
 */
interface CountInfo {
	action: Action,
	ip: string,
	time: number, // Begin time
	count: number,
}

// The list of limits
const list : Array<CountInfo> = [];

export class APILimitHelper {

	/**
	 * Trigger the counter (increase it by one)
	 * 
	 * @param ip Target IP address
	 * @param action The action to check
	 */
	public static async Trigger(ip: string, action: Action) {
		// TODO : trigger counter
	}

	/**
	 * Count the number of actions perfomed by a user
	 * 
	 * @param ip Target IP address
	 * @param action The action to check
	 */
	public static async Count(ip: string, action: Action) : Promise<number> {
		// TODO : return count
		return 0;
	}
}

